

// input keycodes
// hoch, runter, links rechts, laufen, ducken, springen, benutzen, reload, Mausempfindlichkeit, haftreibung, luftreibung, gravitation
var Eingabewerte[13] = 17, 31, 30, 32, 29, 42, 57, 18, 19, 15, 0.5, 0.05, 1.84;
var Bewegungsbefehle[8];	// Movement-commands

var Waffendaten[150];	// Weapon data, get's filled with DEFINE-Values (8x9 Array)
var WaffenMuni[10];	// Store collected ammunition
var WaffenMaga[10];	// Store magazine
var WaffenWeap[10];	// Store weapons

var Herzchen[6];

var Respawns;

var Levelborder[3] = 50000, 50000, 0;	// Defines where sandstorms start

var Messagecounter;	// Counter for "Message-collections"
// 0-Ammo/Weapons

var TEMPs[8];

var pan_normal;

var Spielerzahl;	// Playercount
var Spieler[4];	// Player
var Spielstand[8];	// Kills/ Spaxs

var MyChar[3] = 1, 3;	// Stores the character ID of the choosen player character
var Levelwahl[3] = 1, 6;	// To choose a level (level+max levels)
var Levelrequest;	// Send from a Client to the Server to recieve level data

var Serverlogout;	// A Server/ Server/ Client logged out

var Name_Transmission;	// If this var is != 0 all Name-requests have to wait!
var Name_Request;			// Contains a player-number to get the Player-name

var change_Request;	// Player number + weapon number
var change_Request_to_Server;

var EffektID[4];	// Used to send effects to the Clients (vec+ID)
var EffektID_to_Server[4];	// From a Client to the Server which distibutes

var StepSoundID[5];	// Used to send Stepsounds to the Clients (vec+ID+vol)
var StepSoundID_to_Server[5];	// From a Client to the Server which distributes
var ShotSoundID[4];	// Used to send Shotsounds to the Clients (vec+ID)
var ShotSoundID_to_Server[4];	// From a Client to the Server which distributes
var HitnSoundID[4];	// Used to send Hitsounds to the Clients (vec+ID)
var HitnSoundID_to_Server[4];	// From a Client to the Server which distributes

var_nsave filehandle;

// Skills
DEFINE _Spieler_nummer,			SKILL1;	// Player-number
DEFINE _Object_ID,				SKILL1;	// IDs for Ingame Objects

DEFINE _KP,							SKILL2;	// Hitpoints
DEFINE _Respawn_Timer,			SKILL2;	// Respawn of objects
DEFINE _TEMP_KP,					SKILL3;	// This skill will be used to change our hitpoints

DEFINE _Waffenart,				SKILL4;

DEFINE _AktionM,					SKILL5;
DEFINE _AktionW,					SKILL6;

DEFINE _Main_Anim,				SKILL7;

DEFINE _charakter,				Skill10;

DEFINE _soll_force_X,			SKILL11;	// speed to reach
DEFINE _soll_force_Y,			SKILL12;
DEFINE _soll_force_Z,			SKILL13;

DEFINE _speed_n_save_X,			SKILL14;	// current speed (framerate independent)
DEFINE _speed_n_save_Y,			SKILL15;
DEFINE _speed_n_save_Z,			SKILL16;

DEFINE _TEMP_SPD_X,				SKILL17;	// current speed (framerate independent)
DEFINE _TEMP_SPD_Y,				SKILL18;
DEFINE _TEMP_SPD_Z,				SKILL19;

DEFINE _TEMP_ROT_PAN,			SKILL20;	// Angle
DEFINE _TEMP_ROT_TILT,			SKILL21;
DEFINE _TEMP_ROT_ROLL,			SKILL22;

DEFINE _TEMP_POS_X,				SKILL23;
DEFINE _TEMP_POS_Y,				SKILL24;
DEFINE _TEMP_POS_Z,				SKILL25;

DEFINE _TEMP_ANG_PAN,			SKILL26;
DEFINE _TEMP_ANG_TILT,			SKILL27;
DEFINE _TEMP_ANG_ROLL,			SKILL28;

DEFINE _SHOT_POS_X,				SKILL29;
DEFINE _SHOT_POS_Y,				SKILL30;
DEFINE _SHOT_POS_Z,				SKILL31;

DEFINE _Real_Speed,				SKILL32;
DEFINE _TEMP_Real_Speed,		SKILL33;

DEFINE _SEND_TIMER,				SKILL34;

DEFINE _Waffe,						SKILL35;
DEFINE _WTimer,					SKILL36;

DEFINE _Sniper,					SKILL37;	// Could be flag but must be send

DEFINE _Waffe_lokal,				SKILL38;

DEFINE _SoundID,					SKILL39;	// For local sounds activated on the Server
DEFINE _Getroffen,				SKILL40;	// Hit direction

DEFINE _TEMP_YOU,					SKILL41;	// For dynamite damage

DEFINE _Artillery,				SKILL42;	// Using Artillery
DEFINE _TEMP_WTimer,				SKILL43;	// New timer to send the remaining time of dynamite

DEFINE _Ducken,					SKILL47;
DEFINE _Alt_Anim,					SKILL48;	// alternative animation

DEFINE _Gravitas,					SKILL49;

DEFINE _Neigungswinkel,			SKILL50;
DEFINE _Seitenwinkel,			SKILL51;


DEFINE _Wurfwaffe,				FLAG1;
DEFINE _Animationsrichtung,	FLAG2;
DEFINE _Animationswahl,			FLAG4;
DEFINE _Stepsound,				FLAG5;
DEFINE _Aready_dead,				FLAG6;


DEFINE hoch,      0;	// up
DEFINE runter,    1;	// down
DEFINE links,     2;	// left
DEFINE rechts,    3;	// right
DEFINE gehen,     4;	// creep
DEFINE ducken,		5;	// duck
DEFINE springen,  6;	// jump
DEFINE benutzen,  7;	// use
DEFINE nachladen, 8;	// reload
DEFINE mauskraft, 9;	// mouse-force
DEFINE hreibung, 10;	// ground-friction
DEFINE lreibung, 11;	// air-friction
DEFINE gravita,  12;	// gravitation

DEFINE move_friction_ground,	0.25;
DEFINE move_friction_air,		0;

// MAktionen
DEFINE stehen, 10;	// stand
DEFINE drehen, 11;	// turn
DEFINE laufen, 20;	// walk
DEFINE rennen, 30;	// run
DEFINE fallen, 40;	// fall
// WAktionen
// 10 do nothing
// 20 shot
// 30 change weapon
// 40 reload

DEFINE Fallschaden,				-24;
DEFINE Dynamitzeit,				 40;
DEFINE Umgebungsschaden,		320;

// Weapon Numbers
DEFINE Keine_Waffe, 0;
DEFINE NUM_Waffe_1, 1;
DEFINE NUM_Waffe_2, 2;
DEFINE NUM_Waffe_3, 3;
DEFINE NUM_Waffe_4, 4;
DEFINE NUM_Waffe_5, 5;
DEFINE NUM_Waffe_6, 6;
DEFINE NUM_Waffe_7, 7;
DEFINE NUM_Waffe_8, 8;
DEFINE NUM_Waffe_9, 9;

// Weapon Damage
DEFINE DMG_Waffe_1,		 18;	// Fists
DEFINE DMG_Waffe_2,		 16;	// Peace Maker
DEFINE DMG_Waffe_3,		 20;	// Colt Root
DEFINE DMG_Waffe_4,		 24;	// Winchester
DEFINE DMG_Waffe_5_1,	 80;	// Enfield Musket shot
DEFINE DMG_Waffe_5_2,	 30;	// Enfield Musket Tackle
DEFINE DMG_Waffe_9,		 80;	// Dynamite

// Hitpoints of the Bullets
DEFINE HIT_Waffe_1,		 30;
DEFINE HIT_Waffe_2,		 60;
DEFINE HIT_Waffe_3,		100;
DEFINE HIT_Waffe_4,		 75;
DEFINE HIT_Waffe_5,		140;
DEFINE HIT_Waffe_9,		100;

// Tackle-range
DEFINE RAN_Waffe_1,		 60;	// Fist Range (starts much closer at the palyer as the musket)
DEFINE RAN_Waffe_5,		 80;	// Enfield Musket

// Shot Frequency
DEFINE FRQ_Waffe_1,		  5;
DEFINE FRQ_Waffe_2_1,	  8;
DEFINE FRQ_Waffe_2_2,	  6;
DEFINE FRQ_Waffe_3,		 12;
DEFINE FRQ_Waffe_4,		 16;
DEFINE FRQ_Waffe_5_1,	 16;
DEFINE FRQ_Waffe_5_2,	  8;
DEFINE FRQ_Waffe_9,		 16;

// Ammo Pack size
DEFINE AMO_Waffe_2,		  6;
DEFINE AMO_Waffe_3,		  6;
DEFINE AMO_Waffe_4,		 15;
DEFINE AMO_Waffe_5,		  8;
DEFINE AMO_Waffe_9,		  2;

// Ammo Mag. size
DEFINE MAG_Waffe_2,		  6;
DEFINE MAG_Waffe_3,		  6;
DEFINE MAG_Waffe_4,		 15;
DEFINE MAG_Waffe_5,		  1;

// Vertex points where the traces start
DEFINE VTX_Waffe_1_1,	 35;
DEFINE VTX_Waffe_1_2,	163;
DEFINE VTX_Waffe_2,		325;
DEFINE VTX_Waffe_3,		360;
DEFINE VTX_Waffe_4,		 79;
DEFINE VTX_Waffe_5_1,	 79;
DEFINE VTX_Waffe_5_2,	165;
DEFINE VTX_Waffe_9,		114;

// Sound IDs of the weapons
DEFINE SND_Waffe_1,		 14;
DEFINE SND_Waffe_2,		  3;
DEFINE SND_Waffe_3,		 11;
DEFINE SND_Waffe_4,		 17;
DEFINE SND_Waffe_5_1,	 10;
DEFINE SND_Waffe_5_2,	 13;
DEFINE SND_Waffe_9,		  6;

// Animation ID of the weapon
DEFINE ANI_Waffe_1,		  7;
DEFINE ANI_Waffe_2,		  1;
DEFINE ANI_Waffe_3,		  1;
DEFINE ANI_Waffe_4,		  1;
DEFINE ANI_Waffe_5_1,	  6;
DEFINE ANI_Waffe_5_2,	  1;
DEFINE ANI_Waffe_9,		  3;

// Weapon accuracy
DEFINE ACU_Waffe_1,       2;
DEFINE ACU_Waffe_2,      10;
DEFINE ACU_Waffe_3,       6;
DEFINE ACU_Waffe_4,       4;
DEFINE ACU_Waffe_5,       2;

// Array Offset
DEFINE OFS_DMG_1,	-15;
DEFINE OFS_DMG_2, -14;
DEFINE OFS_HIT,   -13;
DEFINE OFS_RAN,   -12;
DEFINE OFS_FRQ_1, -11;
DEFINE OFS_FRQ_2,	-10;
DEFINE OFS_AMO,    -9;
DEFINE OFS_MAG,    -8;
DEFINE OFS_VTX_1,  -7;
DEFINE OFS_VTX_2,  -6;
DEFINE OFS_SND_1,  -5;
DEFINE OFS_SND_2,  -4;
DEFINE OFS_ANI_1,  -3;
DEFINE OFS_ANI_2,  -2;
DEFINE OFS_ACU,    -1;

// Array dimensions
DEFINE ARR_DIM,	15;



DEFINE Feuer_gross_Gelb,				1;
DEFINE Feuer_gross_Rot,					2;
DEFINE Feuer_gross_Rot_splatt,		3;
DEFINE Feuer_gross_Weiss,				4;
DEFINE Feuer_klein_Gelb,				5;
DEFINE Rauch_Klein,        			6;
DEFINE Rauch_Klein_multi,           7;
DEFINE Explosion,                   8;
DEFINE Splitter,                    9;



DEFINE TRUE,  1;
DEFINE FALSE, 0;


STRING TEMP_STRING[20];
STRING OBJ_STRING[20];	// For simlifying object creation
STRING LEVEL_STRING[20];

STRING Spielstandswerte[30];	// Kills/ Spaxs
STRING Collect_Message[32];	// Prints collected items
STRING Munitionsanzeige[20];	// Ammo-String

STRING MMS[256];	// Main-Message-String
STRING MMS_Senden[256];	// Main-Message-String
STRING MMS_TEMP[256];	// MMS queue

STRING Spielername[20];	// Name of the player, local
STRING Spielername_to_Server[20];	// Contains a player-name send from a Client to the Server

STRING ChatMsg_Inkey[96];	// Chat string for inkey, local
STRING ChatMsg[96];	// Finished chat string, recieved from the server
STRING ChatMsg_to_Server[96];	// Finished chat string, send to the server

var ChatMsg_Timer;
STRING ChatMsg_1[96];	// They are shown finally
STRING ChatMsg_2[96];
STRING ChatMsg_3[96];


SOUND ric5, <ric5.wav>;
SOUND gun_shot, <Gun_Shot.wav>;
SOUND MUSKET4, <MUSKET4.wav>;
SOUND hihihihi, <hihihihi.wav>;
SOUND Booom, <Booom.wav>;
SOUND Autsch, <Autsch.wav>;
SOUND Gunrel, <Gunrel.wav>;
SOUND Schhhh, <Schhhh.wav>;
SOUND Glasss, <Glass2.wav>;
SOUND 357_cock1, <357_cock1.wav>;
SOUND haha3, <haha3.wav>;
SOUND scream4, <scream4.wav>;
SOUND swing, <swing.wav>;
SOUND colt, <colt.wav>;
SOUND Hit, <Hit.wav>;
SOUND Swusch1, <Swusch1.wav>;
SOUND walkhv, <walkhv.wav>;
SOUND walkmd, <walkmd.wav>;
SOUND walksn, <walksn.wav>;
SOUND biggun2, <biggun2.wav>;
SOUND PUNCH, <PUNCH.wav>;
SOUND Hitholz, <Hitholz.wav>;


FONT mid_bangle = "Bangle", 1, 16;
FONT big_bangle = "Bangle", 1, 32;

BMAP Rauch1 = <Rauch02.tga>;
BMAP Rauch2 = <Rauch03.tga>;
BMAP Flamme3 = <Flamme3.tga>;
BMAP Flamme4 = <Flamme4.tga>;
BMAP Flamme6 = <Flamme6.tga>;

BMAP rot = <rot.bmp>;
BMAP schwarz = <schwarz.bmp>;
BMAP cross = <cross.bmp>;

BMAP skydome0 = <skydome0.bmp>;
BMAP skydome1 = <skydome1.bmp>;
BMAP skydome2 = <skydome2.bmp>;
BMAP skydome3 = <skydome3.bmp>;
BMAP skydome4 = <skydome4.bmp>;
BMAP skydome5 = <skydome5.bmp>;

BMAP char_a = <char_a.bmp>;
BMAP char_b = <char_b.bmp>;
BMAP char_c = <char_c.bmp>;

BMAP next  = <next.bmp>;
BMAP prev  = <prev.bmp>;
BMAP start = <start.bmp>;

BMAP Maus = <Maus.bmp>;

BMAP HP_F = <HP_F.bmp>;
BMAP HP_E = <HP_E.bmp>;
BMAP HP_H = <HP_H.bmp>;
BMAP HZV1 = <HZV1.bmp>;
BMAP HZV2 = <HZV2.bmp>;
BMAP HZH1 = <HZH1.bmp>;
BMAP HZH2 = <HZH2.BMP>;